@ECHO OFF
REM
REM Usage: DFix (C,O) (S,D) (OBJname) (PlusChars) [Opt1] [Opt2] [Opt3] [Opt4]
REM C - input file is COFF, O - input file is OMF
REM S - standard - no dumps, D - "debug mode": dump and archive object files
REM OBJname - name of object file without end $ and without extension
REM These files must exist: FileName.dpr and FileName$.obj
REM then OBJName is FileName
REM PlusChars - characters appended to dump/archive file names
REM
REM
REM Directory variables must end with \
REM
REM Directory containing LINK.exe
IF .%MSLINKDIR%==. SET MSLINKDIR=
REM Directory containing COFF2OMF.exe
IF .%COFF2OMFDIR%==. SET COFF2OMFDIR=
REM Directory containing TDUMP.exe
IF .%TDUMPDIR%==. SET TDUMPDIR=
REM Directory containing DCC32.exe
IF .%DCC32DIR%==. SET DCC32DIR=
REM Directory containing OMF2D.exe
IF .%OMF2DDIR%==. SET OMF2DDIR=
REM
REM
IF .%1==.O GOTO IS_OMF
:IS_COFF
IF .%2==.S GOTO IS_STD_0
COPY /B %3$.obj %3$%4_COFF.obj >NUL
%MSLINKDIR%LINK.exe -DUMP /ALL %3$.obj > %3$%4_COFF.txt
:IS_STD_0
%DIR%COFF2OMF.exe %3$.obj
:IS_OMF
IF .%2==.S GOTO IS_STD_1
COPY /B %3$.obj %3$%4_OMF_BEFORE.obj >NUL
%TDUMPDIR%TDUMP.exe %3$.obj > %3$%4_OMF_BEFORE.txt
:IS_STD_1
IF NOT .%OS%==. GOTO IS_NT
DIR /B @ > %3$.dh
GOTO CONT
:IS_NT
COPY NUL %3$.dh >NUL
:CONT
ECHO.
ECHO Trying DCC32 ...
ECHO.
%DCC32DIR%DCC32.exe -D%4 %3.dpr
%OMF2DDIR%OMF2D.exe %3$.obj %5 %6 %7 %8 > %3$.dh
ECHO.
IF .%2==.S GOTO IS_STD_2
COPY /B %3$.obj %3$%4_OMF_AFTER.obj >NUL
%TDUMPDIR%TDUMP.exe %3$.obj > %3$%4_OMF_AFTER.txt
:IS_STD_2
ECHO Trying DCC32 ...
ECHO.
%DCC32DIR%DCC32.exe -D%4 %3.dpr
PAUSE >NUL
CLS