
typedef struct _Fixu32_Thread {
  BYTE Thred :2;
  BYTE Method :3;
  BYTE Zero :1;
  BYTE D :1;
  BYTE IsFixup :1;
} Fixu32_Thread, *PFixu32_Thread;

#define OMF_FIXU32_FIXUP_LOCAT_OFFSET32 0x09
#define OMF_FIXU32_FRAMEMETHOD_SEGDEF  0x00
#define OMF_FIXU32_FRAMEMETHOD_GRPDEF  0x01
#define OMF_FIXU32_FRAMEMETHOD_EXTDEF  0x02
#define OMF_FIXU32_FRAMEMETHOD_LXDAXX  0x04
#define OMF_FIXU32_FRAMEMETHOD_TARGET  0x05
#define OMF_FIXU32_TARGETMETHOD_SEGDEF  0x00
#define OMF_FIXU32_TARGETMETHOD_GRPDEF  0x01
#define OMF_FIXU32_TARGETMETHOD_EXTDEF  0x02

typedef struct _Fixu32_Fixup_Locat {
  BYTE DataRecordOffsetHigh :2;
  BYTE Location :4;
  BYTE M :1;
  BYTE IsFixup :1;
  BYTE DataRecordOffsetLow :8;
} Fixu32_Fixup_Locat, *PFixu32_Fixup_Locat;

typedef struct _Fixu32_Fixup_FixData {
  BYTE Targt :2;
  BYTE P :1;
  BYTE T :1;
  BYTE Frame :3;
  BYTE F :1;
} Fixu32_Fixup_FixData, *PFixu32_Fixup_FixData;


  if(NameEditor)
    goto omf2d_ignore;
  RemoveThisFIXU32 = SkipThisFIXU32 = FALSE;
  *pwrite = OMF_FIXU32; 
  *( PWORD)&pwrite[1] = 1; //cs
  prstring  = pread +1 +2;
  pwstring  = pwrite+1 +2;
  precend   = prstring +RecordLength -1;
  while(prstring < precend) {
    #define _pThread   ((PFixu32_Thread)&prFixupStart[0])
    #define _pLocat    ((PFixu32_Fixup_Locat)&prFixupStart[0])
    #define _pFixData  ((PFixu32_Fixup_FixData)&prFixupStart[2])
    #define _pLocatW   ((PFixu32_Fixup_Locat)&pwFixupStart[0])
    #define _pFixDataW ((PFixu32_Fixup_FixData)&pwFixupStart[2])

    prFixupStart = prstring;
    pwFixupStart = pwstring;
    if((*pwstring++ = *prstring++) & 0x80) {
      if(_pLocat->Location != OMF_FIXU32_FIXUP_LOCAT_OFFSET32) {
        if(!DoNotRemoveFixups) {
          RemoveThisFIXU32 = TRUE;
          _ftprintf(stderr, _T("OMF2D: Non Offset32 fixups removed.\n"));
        }
        else {
          SkipThisFIXU32 = TRUE;
          _ftprintf(stderr, _T("OMF2D: Non Offset32 fixups ignored.\n"));
        }
        break;
      }

      *pwstring++ = *prstring++;
      *pwstring++ = *prstring++;
      if((!_pFixData->F) && (_pFixData->Frame < 4)) {
        prstring += GetIndex(prstring, &FrameDatum, _pFixData->Frame  == OMF_FIXU32_FRAMEMETHOD_SEGDEF, &FrameComdefSegmentIndex);
        pwstring += GroupIndexLength = SetIndex(pwstring, FrameDatum);
      }
      if(!_pFixData->T) {
        prstring += GetIndex(prstring, &TargetDatum, _pFixData->Targt == OMF_FIXU32_TARGETMETHOD_SEGDEF, &TargetComdefSegmentIndex);
        pwstring += SegmentIndexLength = SetIndex(pwstring, TargetDatum);
      }
      i = (_pLocat->DataRecordOffsetLow) +(_pLocat->DataRecordOffsetHigh << 8);
   
      if(TargetComdefSegmentIndex) {
        *(PDWORD)&pLastLXDAXX[i] += ComdefSegments[TargetComdefSegmentIndex].Start;
      }

      if(!_pFixData->P) {
//        if(_pLocat->Location == OMF_FIXU32_FIXUP_LOCAT_OFFSET32) {
          _pFixDataW->P = 1;
          *(PDWORD)&pLastLXDAXX[i] += *(PDWORD)prstring;
//        }
//        else {
//          *(PDWORD)pwstring = *(PDWORD)prstring;
//          pwstring += sizeof(DWORD);
//        }
        prstring += sizeof(DWORD);
      }

      if(//(_pLocat->Location == OMF_FIXU32_FIXUP_LOCAT_OFFSET32) &&
           (!DoNotHandleDllImport)
        && (_pLocat->M) && (!_pFixData->T) && (_pFixData->Targt == OMF_FIXU32_TARGETMETHOD_EXTDEF)
        && (!_pFixData->F) && (_pFixData->Frame < 4) && (ExtDefs[TargetDatum].dbFlags & OMF2D_ED_DLLIMPORT)
        && ((i > 0) || (pPreLastLXDAXX))) {

        ComSize = 0;

        if(i == 0) {
          OrgByte[0] = pPreLastLXDAXX[PreLastLXDAXXSize -2];
          OrgByte[1] = pPreLastLXDAXX[PreLastLXDAXXSize -1];
        }
        else {
          if(i == 1) {
            OrgByte[0] = pPreLastLXDAXX[PreLastLXDAXXSize -1];
            OrgByte[1] = pLastLXDAXX[0];
          }
          else {
            OrgByte[0] = pLastLXDAXX[i -2];
            OrgByte[1] = pLastLXDAXX[i -1];
          }
        }
        
        NewByte[0] = 0x36;
        ComSize = 2;
        switch(OrgByte[0]) {
          case 0xFF :
            M = 0;
            switch(OrgByte[1]) {
              case 0x15 : NewByte[1] = 0xE8; break;
              case 0x25 : NewByte[1] = 0xE9; break;
              case 0x35 : NewByte[1] = 0x68; break;
              default   : ComSize = 0;
            }
            break;
          case 0x8B :
            M = 1;
            if((OrgByte[1] & 0xC7) == 5) {
              NewByte[1] = 0xB8 + ((OrgByte[1] & 0x38) >>3);
            }
            else {
              ComSize = 0;
            }
            break;
          default  :
            ComSize = 0;
        }

        if(ComSize == 0 ) {
          if(OrgByte[1] == 0xA1) {
            ComSize = 1;
            M = 1;
            OrgByte[0] = OrgByte[1];
            NewByte[0] = 0xB8;
          }
        }

        if(ComSize != 0) {
          for(j = 0; j < ComSize; j++) {
            if((i +j) < ComSize) {
              pPreLastLXDAXX[PreLastLXDAXXSize +i -ComSize +j] = NewByte[j];
            }
            else {
              pLastLXDAXX[i -ComSize +j] = NewByte[j];
            }
           _ftprintf(stderr, _T("OMF2D: New file offset %#x: %u Code byte change: %02X -> %02X.\n"),
             ((i +j) < ComSize) ? (pPreLastLXDAXX +PreLastLXDAXXSize +i -ComSize +j -(PBYTE)outbuf) : (pLastLXDAXX +i -ComSize +j -(PBYTE)outbuf),
             j, OrgByte[j], NewByte[j]);
          }
          _pFixDataW->Frame = OMF_FIXU32_FRAMEMETHOD_TARGET;
          pwstring  = pwFixupStart +2 +1;
          pwstring += SetIndex(pwstring, TargetDatum);
          if(_pLocatW->M != M) {
            j = pwFixupStart[0];
            _pLocatW->M = M;
            _ftprintf(stderr, _T("OMF2D: New file offset %#x: ^-> Fixup byte change: %02X -> %02X.\n"),
              pwFixupStart -(PBYTE)outbuf, j, pwFixupStart[0]);
          }
        }
      }

      //Fix frame = EXTDEF, LXDAXX, MASM EXTERN AS label
      if((!_pFixDataW->T) && (!_pFixDataW->F) && ((_pFixDataW->Frame == OMF_FIXU32_FRAMEMETHOD_EXTDEF) || (_pFixDataW->Frame == OMF_FIXU32_FRAMEMETHOD_LXDAXX))) {
        //_pFixDataW->F = 1; //?
        _pFixDataW->Frame = OMF_FIXU32_FRAMEMETHOD_TARGET;
        pwstring += SetIndex(pwstring -= GroupIndexLength +SegmentIndexLength, TargetDatum);
      }

      //Fix SI[x], SI[x]  //MASM bug
      if((!_pFixDataW->T) && (!_pFixDataW->F) && ((_pFixDataW->Frame == OMF_FIXU32_FRAMEMETHOD_SEGDEF) && (_pFixDataW->Targt == OMF_FIXU32_FRAMEMETHOD_SEGDEF))) {
        pwstring += SetIndex(pwstring -= SegmentIndexLength, FrameDatum);
      }

      if((!_pFixDataW->T) && (_pFixDataW->Targt == OMF_FIXU32_TARGETMETHOD_EXTDEF)) { //fix ABS
        if(ExtDefs[TargetDatum].dbFlags & OMF2D_ED_ISABS) {
          *(PDWORD)&pLastLXDAXX[i] = ExtDefs[TargetDatum].dwValue;
          pwstring = pwFixupStart;
        }
      }

      *( PWORD)&pwrite[1] += pwstring -pwFixupStart;
      if( (pLastLXDAXXRecord[0] == OMF_LIDATA) || (pLastLXDAXXRecord[0] == OMF_LIDA32) )
        _ftprintf(stderr, _T("OMF2D: Fixup for LIDAXX found. Next OMF2D versions may support conversion.\n"));
    }             
    else {
      pwstring--;
      if(_pThread->Method < 4)
        if(*prstring++ & 0x80)
          prstring++;
      _ftprintf(stderr, _T("OMF2D: Thread subrecord found and removed.\n"));
    }
  }
  if(!RemoveThisFIXU32) {
    if(SkipThisFIXU32) {
      RecordLength += 3;
      while(RecordLength--)
        *pwrite++ = *pread++;
    }
    else {
      pwrite += *( PWORD)&pwrite[1] +1 +2 -1;
      *pwrite++ = 0; //cs
      pread  += RecordLength +1 +2;
    }
  }
  else
    pread  += RecordLength +1 +2;
