.586P

IFDEF _TASM_
  LARGESTACK
  GROUP FLAT X_CODES, X_CONSTS, X_DATAS
ENDIF

ASSUME CS :FLAT
ASSUME DS :FLAT
ASSUME SS :FLAT

CPLX STRUCT
;  CPLX_00 DW ?
  CPLX_01 DD 32  DUP ('DDDD')
  CPLX_02 DW 64  DUP ('WW')
  CPLX_03 DB 128 DUP ('B')
CPLX ENDS


X_CONSTS SEGMENT USE32 'CONST';---------------------------

MAX_MS_ITS_DW EQU 513
MAX_MS_ITS_DD EQU 257

DB  ?

BBs DB 65536 DUP('B')

ORG $+30

WWs DW MAX_MS_ITS_DW+1 DUP ('WW')

;ALIGN 8

DDs DD MAX_MS_ITS_DD+1 DUP ('DDDD')
X_CONSTS ENDS
;----------------------------------


X_DATAS SEGMENT USE32 'DATA';----------------------------

cplx CPLX 20 DUP (<>)
ocplx DD cplx
;----------------------------------

COMM CommVar00 :DWORD:3, CommVar01 :WORD:2, CommVar02 :BYTE
X_DATAS ENDS

X_CODES SEGMENT USE32 'CODE';----------------------------

DB ?
CodeVar00 DD 2 DUP (23)

ORG $+32

PUBLIC FunctionS
FunctionS PROC STDCALL USES EBX, Param00 :DWORD, Param01 :DWORD
  MOV    CodeVar00, ECX
  MOV    EBX, ocplx
  MOV    EAX, CodeVar00[0]
  MOV     CX, (CPLX PTR [EBX]).CPLX_02[4]
  MOV     DL, BBs[3]
  MOV    CommVar00[2 *(4)], EAX
  MOV    CommVar01[1 *(2)],  CX
  MOV    CommVar02[0 *(1)],  DL
  MOVZX  EAX,  WWs[1 *(2)]
  ADD    EAX, Param00
  ADD    EAX, Param01
  RET
  CALL   FunctionTestImport
FunctionS ENDP

PUBLIC FunctionC
FunctionC PROC C USES EBX, Param00 :DWORD, Param01 :DWORD, Param02 :DWORD
  MOV    EBX, ocplx
  MOV    EAX, CodeVar00[0]
  MOV     CX, (CPLX PTR [EBX]).CPLX_02[4]
  MOV     DL, BBs[3]
  MOV    CommVar00[2 *(4)], EAX
  MOV    CommVar01[1 *(2)],  CX
  MOV    CommVar02[0 *(1)],  DL
  MOVZX  EAX,  WWs[1 *(2)]
  ADD    EAX, Param00
  ADD    EAX, Param01
  RET
FunctionC ENDP

PUBLIC FunctionF
FunctionF PROC STDCALL USES EBX, Param03 :DWORD
  MOV    EBX, ocplx
  MOV    EAX, CodeVar00[0]
  MOV     CX, (CPLX PTR [EBX]).CPLX_02[4]
  MOV     DL, BBs[3]
  MOV    CommVar00[2 *(4)], EAX
  MOV    CommVar01[1 *(2)],  CX
  MOV    CommVar02[0 *(1)],  DL
  MOVZX  EAX,  WWs[1 *(2)]
  ADD    EAX, Param03
  RET
FunctionF ENDP

PUBLIC FunctionP
FunctionP PROC PASCAL USES EBX, Param00 :DWORD
  MOV    EBX, ocplx
  MOV    EAX, CodeVar00[0]
  MOV     CX, (CPLX PTR [EBX]).CPLX_02[4]
  MOV     DL, BBs[3]
  MOV    CommVar00[2 *(4)], EAX
  MOV    CommVar01[1 *(2)],  CX
  MOV    CommVar02[0 *(1)],  DL
  MOVZX  EAX,  WWs[1 *(2)]
  ADD    EAX, Param00
  RET
FunctionP ENDP

GetVersion  PROTO STDCALL
ExitProcess PROTO STDCALL :DWORD
wsprintfA   PROTO C :DWORD, :DWORD, :DWORD

FunctionTestImport PROC
IFDEF _TASM_ 
  CALL   GetVersion
  CALL   ExitProcess, 0
  CALL   wsprintfA, 0, 0, 0
ELSE
  INVOKE GetVersion
  INVOKE ExitProcess, 0
  INVOKE wsprintfA, 0, 0, 0
ENDIF
FunctionTestImport ENDP
X_CODES ENDS
;----------------------------------
END