
  //if continuation, DataOffset is ok, just check for lidata gap

  #define OMF_COMDAT_FLAGS_CONTINUATION 1
  #define OMF_COMDAT_FLAGS_LIDAXX       2
  #define OMF_COMDAT_FLAGS_LCOMDAT      4
  #define OMF_COMDAT_FLAGS_DATAINCODE   8

  if(NameEditor)
    goto omf2d_ignore;
  prstring = pread +1 +2;
//  precend  = prstring +RecordLength -1;
  j = 0;
  DataOffset = *(PDWORD)&prstring[3];
  TwoOrFour = 4;
  if(RecordType == OMF_COMDAT) {
    DataOffset &= 0xFFFF;
    TwoOrFour -= 2;
  }
  TypeIndexLength = GetIndex(prstring +3 +TwoOrFour, &TypeIndex, FALSE, NULL);
  switch(prstring[1] & 0x0F) {
    case 0x0F :
    case 0x0E :
    case 0x0D :
    case 0x0C :
    case 0x0B :
    case 0x0A :
    case 0x09 :
    case 0x08 :
    case 0x07 :
    case 0x06 :
    case 0x05 :
    case 0x00 : GroupIndexLength    = GetIndex(prstring +3 +TwoOrFour +TypeIndexLength, &GroupIndex, FALSE, NULL);
                SegmentIndexLength  = GetIndex(prstring +3 +TwoOrFour +TypeIndexLength +GroupIndexLength, &SegmentIndex, FALSE, NULL);
                if(SegmentIndex == 0)
                  j = 2;
                break;
//    case 0x01 :
//    case 0x02 : return(_ftprintf(stderr, _T("COMDAT for %s16 found - terminating!."), (prstring[1] & 0x0F) == 0x01 ? _T("CODE") : _T("DATA")));
//                break;
    case 0x01 :
    case 0x03 : GroupIndexLength    = 0; GroupIndex = 0;
                SegmentIndexLength  = _TEXTIndexLength; SegmentIndex = _TEXTIndex;
                break;
    case 0x02 : 
    case 0x04 : GroupIndexLength    = 0; GroupIndex = 0;
                SegmentIndexLength  = _DATAIndexLength; SegmentIndex = _DATAIndex;
                break;
  }
  NameIndexLength = GetIndex(prstring +3 +TwoOrFour +TypeIndexLength +GroupIndexLength +SegmentIndexLength +j, &NameIndex, FALSE, NULL);

  if(prstring[0] & OMF_COMDAT_FLAGS_LCOMDAT)
    LocalExtPubName = TRUE;

  if(!(prstring[0] & OMF_COMDAT_FLAGS_CONTINUATION)) {
    *pwrite++ = OMF_PUBD32;
    pwstring = pwrite;
    pwrite += 2;
    pwrite += SetIndex(pwrite, GroupIndex);
    pwrite += SetIndex(pwrite, SegmentIndex);
    if(j) {
      *( PWORD)pwrite = *( PWORD)(prstring +3 +TwoOrFour +TypeIndexLength +GroupIndexLength +SegmentIndexLength);
      pwrite += 2;
    }
    ChangeName(LNames[NameIndex], pwrite, NewPNames, NewPNamesCounter, TRUE);
    pwrite += *pwrite++;
    *(PDWORD)pwrite = *pSegmentSize[SegmentIndex] +DataOffset;
    pwrite += SetIndex(pwrite += 4, TypeIndex);
    *pwrite++ = 0; //cs
    *( PWORD)pwstring = pwrite -pwstring -2;
    ComdatOffsets[SegmentIndex] = 0;
  }

  if(ComdatOffsets[SegmentIndex] < DataOffset) {
    *pwrite++ = OMF_LIDA32;
    *( PWORD)pwrite = ((SegmentIndex > 0x7F) ? 2 : 1) +19;
    pwrite += SetIndex(pwrite += 2, SegmentIndex);
    *(PDWORD)&pwrite[ 0] = *pSegmentSize[SegmentIndex];
    *(PDWORD)&pwrite[ 4] = DataOffset -ComdatOffsets[SegmentIndex]; //rept cnt
    *( PWORD)&pwrite[ 8] = 1;
    *(PDWORD)&pwrite[10] = 1; //rept cnt
    *( PWORD)&pwrite[14] = 0;
    pwrite[16] = 1;
    pwrite[17] = 0;
    pwrite[18] = 0;
    pwrite += 19;
    *pSegmentSize[SegmentIndex] += DataOffset -ComdatOffsets[SegmentIndex];
    ComdatOffsets[SegmentIndex] = DataOffset;
  }

  pLastLXDAXXRecord = pwrite;
  *pwrite++ = (prstring[0] & OMF_COMDAT_FLAGS_LIDAXX) ? OMF_LIDA32 : OMF_LEDA32;
  pwstring = pwrite;
  pwrite += SetIndex(pwrite += 2, SegmentIndex);
  *(PDWORD)pwrite = *pSegmentSize[SegmentIndex];
  pLastLXDAXX = pwrite += 4;
  i = 3 +TwoOrFour +TypeIndexLength +GroupIndexLength +SegmentIndexLength +j +NameIndexLength;
  precend = prstring += i;

  if((pwstring[-1] == OMF_LIDA32)) {
    ComSize = GetLIDAXXBlockSize(prstring, TwoOrFour, NULL);
  }
  else {
    i = ComSize = RecordLength -i -1; //LEDAXX data size
    while(i--)
      *pwrite++ = *prstring++;
  }

  if((pwstring[-1] == OMF_LIDA32) && (pread[RecordLength] == OMF_FIXU32)) {
    pwrite = pLastLXDAXXRecord;
    *pwrite++ = (TwoOrFour == 4) ? OMF_LIDA32 : OMF_LIDATA;
    pwrite += SetIndex(pwrite += 2, SegmentIndex);
    *(PDWORD)pwrite = *pSegmentSize[SegmentIndex];
    pLastLXDAXX = pwrite += TwoOrFour;
    i = RecordLength - i -1;
    while(i--)
       *pwrite++ = *precend;
  }

  *( PWORD)pwstring = pwrite -pwstring -2 +1;
  *pwrite++ = 0; //cs
  ComdatOffsets[SegmentIndex] += ComSize;
  *pSegmentSize[SegmentIndex] += ComSize;

  pread += RecordLength +3;
  LocalExtPubName = FALSE;
