
  LONG WINAPI GetXNameOrdinal(PTCHAR pNum, PWORD pVal) {
    DWORD i;
    if(*pNum == '[') {
      for(i = 1; (pNum[i] != '\0') && (pNum[i] != ']'); i++);
      if(pNum[i] == '\0')
        return(-1);
      pNum[i] = '\0';
      *pVal = strtoul(pNum +1, NULL, 0);
      return(i +1);
    }
    else {
      *pVal = OMF2D_ORDINALANY;
      return(0);
    }
  }

  LONG WINAPI GetOptions(TCHAR **pOptions, DWORD nOptions, TCHAR **pInvalidSwitch) {
    LONG OptionsProcessed = 0, NewOptionsProcessed = 0;
    DWORD i, j;
    for(i = 0; (i < nOptions) && (pOptions[i][0] == '/'); i++) {
      switch(pOptions[i][1]) {
          case 'D' : if((pOptions[i][2] == '-') && (pOptions[i][3] == '\0')) {
                       DoNotHandleDllImport = TRUE;
                       OptionsProcessed++;
                       break;
                     }
                     OptionsProcessed = -1;
                     break;

          case 'F' : if((pOptions[i][2] == '+') && (pOptions[i][3] == '\0')) {
                       DoNotRemoveFixups = TRUE;
                       OptionsProcessed++;
                       break;
                     }
                     OptionsProcessed = -1;
                     break;

          case 'U' : if((pOptions[i][2] == '-') && (pOptions[i][3] == '\0')) {
                       DoNotUndecorate = TRUE;
                       OptionsProcessed++;
                       break;
                     }
                     if((pOptions[i][2] == '_') && (pOptions[i][3] == '*') && (pOptions[i][4] == '\0')) {
                       KeepLeading_ = TRUE;
                       OptionsProcessed++;
                       break;
                     }
                     if((pOptions[i][2] == '*') && (pOptions[i][3] == '_') && (pOptions[i][4] == '\0')) {
                       KeepEnd_ = TRUE;
                       OptionsProcessed++;
                       break;
                     }
                     if(pOptions[i][2] == 'U') {
                       HMODULE hDll;
                       TUndecorateName UUndecorateName;
                       if(hDll = LoadLibrary(&pOptions[i][3]))
                         if(UUndecorateName = (TUndecorateName)GetProcAddress(hDll, "UndecorateName"))
                           UndecorateName = UUndecorateName;
                       OptionsProcessed++;
                       break;
                     }
                     OptionsProcessed = -1;
                     break;

          case 'C' : if((pOptions[i][2] == '+') && (pOptions[i][3] == '\0')) {
                       gNameEditor = TRUE;
                       OptionsProcessed++;
                       break;
                     } 
                     if(pOptions[i][2] == 'L') {
                       j = GetXNameOrdinal(&pOptions[i][3], &NewLNames[NewLNamesCounter].Ordinal);
                       if(j != (DWORD)-1) {
                         NewLNames[NewLNamesCounter].OldName = ( PBYTE)&pOptions[i][j += 3];
                         for(; (pOptions[i][j]) && (pOptions[i][j] != '='); j++);
                         if(pOptions[i][j]) {
                           pOptions[i][j] = 0;
                           NewLNames[NewLNamesCounter].CurOrdinal = 0;
                           NewLNames[NewLNamesCounter++].NewName = ( PBYTE)&pOptions[i][j+1];
                           OptionsProcessed++;
                           break;
                         }
                       }
                       OptionsProcessed = -1;
                       break;
                     }
                     if(pOptions[i][2] == 'E') {
                       j = GetXNameOrdinal(&pOptions[i][3], &NewENames[NewENamesCounter].Ordinal);
                       if(j != (DWORD)-1) {
                         NewENames[NewENamesCounter].OldName = ( PBYTE)&pOptions[i][j +=3];
                         for(; (pOptions[i][j]) && (pOptions[i][j] != '='); j++);
                         if(pOptions[i][j]) {
                           pOptions[i][j] = 0;
                           NewENames[NewENamesCounter].CurOrdinal = 0;
                           NewENames[NewENamesCounter++].NewName = ( PBYTE)&pOptions[i][j+1];
                           OptionsProcessed++;
                           break;
                         }
                       }
                       OptionsProcessed = -1;
                       break;
                     }
                     if(pOptions[i][2] == 'P') {
                       j = GetXNameOrdinal(&pOptions[i][3], &NewPNames[NewPNamesCounter].Ordinal);
                       if(j != (DWORD)-1) {
                         NewPNames[NewPNamesCounter].OldName = ( PBYTE)&pOptions[i][j += 3];
                         for(; (pOptions[i][j]) && (pOptions[i][j] != '='); j++);
                         if(pOptions[i][j]) {
                           pOptions[i][j] = 0;
                           NewPNames[NewPNamesCounter].CurOrdinal = 0;
                           NewPNames[NewPNamesCounter++].NewName = ( PBYTE)&pOptions[i][j+1];
                           OptionsProcessed++;
                           break;
                         }
                       }
                       OptionsProcessed = -1;
                       break;
                     }
                     OptionsProcessed = -1;
                     break;

          case 'O' : if(pOptions[i][2]) {
                       FILE *fi = _tfopen(&pOptions[i][2], _T("rb"));
                       if(fi != NULL) {
                         fseek(fi, 0, SEEK_END);
                         DWORD fisize = ftell(fi);
                         fseek(fi, 0, SEEK_SET);
                         PVOID inbuf = malloc(fisize +1*sizeof(TCHAR));
                         fread(inbuf, 1, fisize, fi);
                         fclose(fi);
                         PTCHAR pread  = (PTCHAR)inbuf;
                         pread[fisize/sizeof(TCHAR)] = 0x0;
                         PTCHAR pfileend = pread +fisize;
                         DWORD nNewOptions = 0;
                         while(pread < pfileend) {
                           while((pread < pfileend) && (*pread <= ' '))
                             *pread++ = '\0';
                           if(pread < pfileend)
                             nNewOptions++;
                           while((pread < pfileend) &&(*pread > ' '))
                             pread++;
                         }
                         TCHAR **pNewOptions  = (TCHAR **)malloc(nNewOptions *sizeof(TCHAR *));
                         pread  = (PTCHAR)inbuf;
                         nNewOptions = 0;
                         while(pread < pfileend) {
                           while((pread < pfileend) &&(!*pread))
                             pread++; 
                           if(pread < pfileend)
                             pNewOptions[nNewOptions++] = pread;
                           while((pread < pfileend) && (*pread))
                             pread++; 
                         }
                         NewOptionsProcessed = GetOptions(pNewOptions, nNewOptions, pInvalidSwitch);
                         OptionsProcessed++;
                         break;
                       }
                     }
                     OptionsProcessed = -1;
                     break;

          case 'S' : if(pOptions[i][2] == 'E') {
                       NewEDValues[NewEDValuesCounter].ExtDefName = ( PBYTE)&pOptions[i][3];
                       for(j = 3; (pOptions[i][j]) && (pOptions[i][j] != '='); j++);
                       if(pOptions[i][j]) {
                         pOptions[i][j] = 0;
                         NewEDValues[NewEDValuesCounter++].dwValue = strtoul(&pOptions[i][j+1], NULL, 0);
                         OptionsProcessed++;
                         break;
                       }
                     }
                     OptionsProcessed = -1;
                     break;

          default  : OptionsProcessed = -1;
                     break;
      }
      if(NewOptionsProcessed != -1) {
        if(OptionsProcessed == -1) {
          *pInvalidSwitch = pOptions[i];
          break;
        }
      }
      else {
        OptionsProcessed = -1;
        break;
      }
    }
    if((OptionsProcessed == -1) || (OptionsProcessed < nOptions)) {
      if(NewOptionsProcessed != -1) {
        *pInvalidSwitch = pOptions[i];
      }
      OptionsProcessed = -1;
    }
    return(OptionsProcessed);
  }
